
#import "RPMHTTPConnection.h"

@interface NSURLConnectionBugTester : NSObject <RPMHTTPConnectionDelegate>
{
    RPMHTTPConnection *_connection;
}
- (void)google;
@end

@implementation NSURLConnectionBugTester

- (void)google
{
    if (_connection)
    {
        [_connection cancel];
        [_connection release];
        _connection = nil;
    }

    _connection = [[RPMHTTPConnection alloc] initWithRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:@"http://www.google.com"]] delegate:self];
}

- (void)connection:(RPMHTTPConnection *)connection finishedWithResponse:(RPMHTTPResponse *)response
{
    NSLog(@"got response from instance: %p, data length: %u", connection, [response.data length]);
    [_connection release];
    _connection = nil;
}

@end

int main(int argc, const char *argv[])
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

    NSURLConnectionBugTester *tester = [[NSURLConnectionBugTester alloc] init];
    [tester google];

    while (YES)
    {
        [[NSRunLoop currentRunLoop] run];
    }

    [pool release];

    return 0;
}
